---
title: WEBGL_compressed_texture_s3tc_srgb
slug: Web/API/WEBGL_compressed_texture_s3tc_srgb
tags:
  - API
  - Reference
  - WebGL
  - WebGL extension
---
<div>{{APIRef("WebGL")}}</div>

<p>The <code><strong>WEBGL_compressed_texture_s3tc_srgb</strong></code> extension is part of the <a href="/en-US/docs/Web/API/WebGL_API">WebGL API</a> and exposes four <a href="https://en.wikipedia.org/wiki/S3_Texture_Compression">S3TC compressed texture formats</a> for the sRGB colorspace.</p>

<p>Compressed textures reduce the amount of memory needed to store a texture on the GPU, allowing for higher resolution textures or more of the same resolution textures.</p>

<p>WebGL extensions are available using the {{domxref("WebGLRenderingContext.getExtension()")}} method. For more information, see also <a href="/en-US/docs/Web/API/WebGL_API/Using_Extensions">Using Extensions</a> in the <a href="/en-US/docs/Web/API/WebGL_API/Tutorial">WebGL tutorial</a>.</p>

<div class="note">
<p><strong>Availability:</strong> This extension is available to both {{domxref("WebGLRenderingContext", "WebGL1", "", 1)}} and {{domxref("WebGL2RenderingContext", "WebGL2", "", 1)}} contexts.</p>
</div>

<h2 id="Constants">Constants</h2>

<p>The compressed texture formats are exposed by four constants and can be used in two functions: {{domxref("WebGLRenderingContext.compressedTexImage2D", "compressedTexImage2D()")}} and {{domxref("WebGLRenderingContext.compressedTexSubImage2D", "compressedTexSubImage2D()")}}.</p>

<dl>
 <dt><code>ext.COMPRESSED_SRGB_S3TC_DXT1_EXT</code></dt>
 <dd>A DXT1-compressed image in an sRGB image format.</dd>
 <dt><code>ext.COMPRESSED_SRGB_ALPHA_S3TC_DXT1_EXT</code></dt>
 <dd>A DXT1-compressed image in an sRGB image format with a simple on/off alpha value.</dd>
 <dt><code>ext.COMPRESSED_SRGB_ALPHA_S3TC_DXT3_EXT</code></dt>
 <dd>A DXT3-compressed image in an sRGBA image format.</dd>
 <dt><code>ext.COMPRESSED_SRGB_ALPHA_S3TC_DXT5_EXT</code></dt>
 <dd>A DXT5-compressed image in an sRGBA image format.</dd>
</dl>

<h2 id="Examples">Examples</h2>

<pre class="brush:js">var ext = gl.getExtension('WEBGL_compressed_texture_s3tc_srgb');

var texture = gl.createTexture();
gl.bindTexture(gl.TEXTURE_2D, texture);

gl.compressedTexImage2D(gl.TEXTURE_2D, 0, ext.COMPRESSED_SRGB_S3TC_DXT1_EXT, 512, 512, 0, textureData);

gl.texParameteri(gl.TEXTURE_2D, gl.TEXTURE_MAG_FILTER, gl.LINEAR);
gl.texParameteri(gl.TEXTURE_2D, gl.TEXTURE_MIN_FILTER, gl.LINEAR);</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('WEBGL_compressed_texture_s3tc_srgb', '', 'WEBGL_compressed_texture_s3tc_srgb')}}</td>
   <td>{{Spec2('WEBGL_compressed_texture_s3tc_srgb')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p class="hidden">The compatibility table in this page is generated from structured data. If you'd like to contribute to the data, please check out <a href="https://github.com/mdn/browser-compat-data">https://github.com/mdn/browser-compat-data</a> and send us a pull request.</p>

<p>{{Compat("api.WEBGL_compressed_texture_s3tc_srgb")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="https://www.khronos.org/opengl/wiki/S3_Texture_Compression#sRGB_and_S3TC">S3 Texture Compression – OpenGL wiki</a></li>
 <li>{{domxref("WebGLRenderingContext.getExtension()")}}</li>
 <li>{{domxref("WebGLRenderingContext.compressedTexImage2D()")}}</li>
 <li>{{domxref("WebGLRenderingContext.compressedTexSubImage2D()")}}</li>
 <li>{{domxref("WebGLRenderingContext.getParameter()")}}</li>
</ul>
